import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

public class HighScore{
 private static final String DATEI = "Highscore.dat";
 private TreeSet set;
	
 public HighScore() throws IOException{
 		this.set = readSorted();
 }
 
 public Player[] getBest(){	
  	Iterator it = this.set.iterator();
		int i;
  	if (set.size()<3) i = set.size();
		else i = 3;
  	Player[] ps = new Player[i];
    	
      for (i=0;i<3 && i<set.size();i++){
				ps[i] = (Player)it.next();
    	}
    	
    	return ps;
 }
 
 public Player[] getAll(){	
   	Iterator it = this.set.iterator();
		Player[] ps = new Player[set.size()];
    	
      for (int i=0;i<set.size();i++){
				ps[i] = (Player)it.next();
    	}
    	
    	return ps;
 }
 
 public void writeScore(Player p1) throws IOException{
	Iterator it = this.set.iterator();
	int newscore;
	
	if(it.hasNext()){
		while(it.hasNext()){
			Player p2 = (Player)it.next();
			if (p2.name.equals(p1.name)){
				newscore = p2.score + p1.score;
				p2.score = newscore;
				break;
			}else if(!it.hasNext()){
				this.set.add(p1);
				break;
			}	
		}
	}else{
		this.set.add(p1);
	}	
	
	this.write();
 }
 
 public void write() throws IOException{
	Iterator it = this.set.iterator();
  	StringBuffer buffy = new StringBuffer();

  	while (it.hasNext()){
		Player p = (Player)it.next();
		buffy.append(p.score+","+p.name+"\n");
	}	
	
	//System.out.println("Buffy"+buffy+"Buffy");
	
 	try {
		FileWriter f1 = new FileWriter(DATEI);
      	f1.write(buffy.toString());
      	f1.close();
	} catch (IOException e) {
	  	System.out.println("Fehler beim Erstellen der Datei : "+ DATEI);
	}
 }
 
public static TreeSet readSorted() throws IOException
 {
 	// Lese Datei in Vector
 	try{
 		FileReader f = new FileReader(DATEI);
 		BufferedReader in = new BufferedReader(f);
		String text;
		TreeSet set = new TreeSet();
		
   	while ((text = in.readLine()) != null) {
      try{
   			StringTokenizer st = new StringTokenizer(text,",");
				int score = Integer.parseInt(st.nextToken());
				String name = st.nextToken();
     		set.add(new Player(score,name));
     	}catch(NoSuchElementException ex){
     		continue;
     	}catch(NumberFormatException ex){
     		continue;
     	} 
  	}
  	in.close();
  	f.close();
  	return set;
  }catch (IOException e){
   throw new IOException("Fehler beim Lesen der Datei :"+ e.getMessage());
  }

 }
 
 public static void main(String args[]){
 	try{	
		HighScore h= new HighScore();
 		System.out.println(h.getBest().length);
 	 		System.out.println(h.getAll().length);
 	
 	}catch(Exception ex){
 		System.err.print(ex);
 	}
 }

}

