import java.awt.*;

// Ein Spieler
public class Player implements Comparable
{
	protected int athome;					// Anzahl der Steine "im Haus"
	protected int inhouse;				// Anzahl der Steine im Ziel
	protected int begin;					// Index des Startfelds
	protected int[] stein = new int[4];	// Positionen der Spielsteine:
															// -1    = im Haus
															// 0-39  = Auf dem Spielfeld
															// 40-43 = Im Ziel
  protected int score = 0;		//Highscore
	protected String name = "";		// Name des Spielers
	protected Color color;				// Farbe des Spielers
	protected Color color_noton;			// Farbe fr unbesetzte Felder (z. B. im Ziel)
	protected Wuerfel wuerfel;
  
  public Player(){
  }	
	
  public Player(int score, String name){
		this.score = score;
		this.name = name;
  }
		
	public Player(String n, Color c, Color cn, int b)
	{
		this.reset();
		begin = b;
		name = n;
		color = c;
		color_noton = cn;
	}
	
  public int compareTo(Object o){
  	Player p = (Player)o;
  	if (p.score < this.score)
    		return -1;
    	else if (p.score > this.score)
    		return 1;
    	else
    		return 0;  	
  }
  
  public void setWuerfel(Wuerfel w){
  	this.wuerfel = w;
  }
  
  public Wuerfel getWuerfel(){
  	return this.wuerfel;
  }
  
	public void reset()
	{
		inhouse = 0;
		athome = 4;
		stein[0] = stein[1] = stein[2] = stein[3] = -1;
	}
		
	public void setName(String n){
		this.name = n;
	}
	
	public String getName()
	{
		return (name);
	}
		
	public Color getColor()
	{
		return (color);
	}
	
	public int getScore(){
		//System.err.println("get"+score);
		return this.score;
	}
	
	public void setScore(int s){
		//System.err.println("set"+s);
		this.score = s;
	}
		
	// ermittelt, ob der Spieler gewonnen hat
	public boolean hasWon()
	{
		return (inhouse == 4);
	}
		
	// ermittelt den aktuellen Punktestand (= Summe aller Steinpositionen)
	public int getPoints()
	{
		return (stein[0] + stein[1] + stein[2] + stein[3] + 4);
	}
		
	// ermittelt die Punkte (= Position) fr einen Stein
	public int getStonePoints(int stone)
	{
		if ((stone < 0) || (stone >= 4))
			return (0);
		return (stein[stone]);
	}
		
	// ermittelt das Spielfeld zu einem Stein
	// (Steinposition != Spielfeldindex!)
	public int getStonePos(int stone)
		{
		if ((stone < 0) || (stone >= 4))
			return (-1);
		if ((stein[stone] == -1) || (stein[stone] >= 40))
			return (stein[stone]);
		return ((stein[stone] + begin) % 40);
	}
	
	public String toString(){
		return this.score + " " + this.name;
	}
}