import java.awt.*;
import java.awt.event.*;


// Ein Panel fr das Spielfeld
public class Spielfeld extends Panel implements ActionListener
	{
	// Platz: Ein Feld auf dem Spielfeld
	private class Platz
		{
		public int besetzt;		// -1: frei, sonst Spielerindex
		public Point pos;		// Position 
		
		public Platz()
			{
			besetzt = KEIN;
			pos = new Point();
			}
		
		public Platz(int x, int y)
			{
			pos = new Point(x, y);
			besetzt = KEIN;
			}
		
		public Platz(int x, int y, int b)
			{
			pos = new Point(x, y);
			besetzt = b;
			if (b < KEIN)
				b = KEIN;
			if (b >= MAX)
				b = GELB;
			}
		}
	
	public static final int KEIN    = -1;	// Kein Spieler
	public static final int MIN     = 0;
	public static final int ROT     = 0;
	public static final int GRN    = 1;
	public static final int SCHWARZ = 2;
	public static final int GELB    = 3;
	public static final int MAX     = 4;	// Anzahl der Spieler
	
	private SelectListener listener;		// Listener fr Auswhlen von Spielsteinen
	private final Platz home[][]  = new Platz[MAX][4];
	private final Platz house[][] = new Platz[MAX][4];
	private final Platz field[]   = new Platz[40];
	
	protected Player[] spieler = new Player[MAX];
	private Label status;
	private PPanel PPanel;
	private Button button;
	
	public Spielfeld()
		{
		setBackground(new Color(255, 255, 128));
		setBounds(0,0,320,320);
		setLayout(null);
		
		spieler[0] = new Player("Rot"    , Color.red, new Color(255, 128, 128), 0);
		spieler[1] = new Player("Grn"   , Color.green.darker().darker(),  Color.green.darker()/*new Color(128, 255, 128)*/, 10);
		spieler[2] = new Player("Schwarz", Color.black,  new Color(128, 128, 128), 20);
		spieler[3] = new Player("Gelb"   , Color.yellow, new Color(255, 255, 128), 30);
		
		home[ROT][0] = new Platz(10, 10, ROT);
		home[ROT][1] = new Platz(38, 10, ROT);
		home[ROT][2] = new Platz(10, 38, ROT);
		home[ROT][3] = new Platz(38, 38, ROT);
		
		home[GRN][0] = new Platz(262, 10, GRN);
		home[GRN][1] = new Platz(290, 10, GRN);
		home[GRN][2] = new Platz(262, 38, GRN);
		home[GRN][3] = new Platz(290, 38, GRN);
		
		home[SCHWARZ][0] = new Platz(262, 262, SCHWARZ);
		home[SCHWARZ][1] = new Platz(290, 262, SCHWARZ);
		home[SCHWARZ][2] = new Platz(262, 290, SCHWARZ);
		home[SCHWARZ][3] = new Platz(290, 290, SCHWARZ);
		
		home[GELB][0] = new Platz(10, 262, GELB);
		home[GELB][1] = new Platz(38, 262, GELB);
		home[GELB][2] = new Platz(10, 290, GELB);
		home[GELB][3] = new Platz(38, 290, GELB);
		
		house[ROT][0] = new Platz(40, 152);
		house[ROT][1] = new Platz(68, 152);
		house[ROT][2] = new Platz(96, 152);
		house[ROT][3] = new Platz(124, 152);
		
		house[GRN][0] = new Platz(152, 40);
		house[GRN][1] = new Platz(152, 68);
		house[GRN][2] = new Platz(152, 96);
		house[GRN][3] = new Platz(152, 124);
		
		house[SCHWARZ][0] = new Platz(264, 152);
		house[SCHWARZ][1] = new Platz(236, 152);
		house[SCHWARZ][2] = new Platz(208, 152);
		house[SCHWARZ][3] = new Platz(180, 152);
		
		house[GELB][0] = new Platz(152, 264);
		house[GELB][1] = new Platz(152, 236);
		house[GELB][2] = new Platz(152, 208);
		house[GELB][3] = new Platz(152, 180);
		
		field[0]  = new Platz(10, 122);
		field[1]  = new Platz(38, 122);
		field[2]  = new Platz(66, 122);
		field[3]  = new Platz(94, 122);
		field[4]  = new Platz(122, 122);
		field[5]  = new Platz(122, 94);
		field[6]  = new Platz(122, 66);
		field[7]  = new Platz(122, 38);
		field[8]  = new Platz(122, 10);
		field[9]  = new Platz(150, 10);
		field[10] = new Platz(178, 10);
		field[11] = new Platz(178, 38);
		field[12] = new Platz(178, 66);
		field[13] = new Platz(178, 94);
		field[14] = new Platz(178, 122);
		field[15] = new Platz(206, 122);
		field[16] = new Platz(234, 122);
		field[17] = new Platz(262, 122);
		field[18] = new Platz(290, 122);
		field[19] = new Platz(290, 150);
		field[20] = new Platz(290, 178);
		field[21] = new Platz(262, 178);
		field[22] = new Platz(234, 178);
		field[23] = new Platz(206, 178);
		field[24] = new Platz(178, 178);
		field[25] = new Platz(178, 206);
		field[26] = new Platz(178, 234);
		field[27] = new Platz(178, 262);
		field[28] = new Platz(178, 290);
		field[29] = new Platz(150, 290);
		field[30] = new Platz(122, 290);
		field[31] = new Platz(122, 262);
		field[32] = new Platz(122, 234);
		field[33] = new Platz(122, 206);
		field[34] = new Platz(122, 178);
		field[35] = new Platz(94, 178);
		field[36] = new Platz(66, 178);
		field[37] = new Platz(38, 178);
		field[38] = new Platz(10, 178);
		field[39] = new Platz(10, 150);
	  
		spieler[0].setWuerfel(new Wuerfel( 60,60 , this));
    spieler[1].setWuerfel(new Wuerfel(220,60 , this));
    spieler[2].setWuerfel(new Wuerfel(220,220, this));
    spieler[3].setWuerfel(new Wuerfel( 60,220, this));

 		this.status = new Label("        FAIR PLAY...        ");
		this.status.setAlignment(Label.CENTER);
 		//this.status.setColumns(15);
		//this.status.setEditable(false);
		
		this.button = new Button("Wrfeln");
		Button("off");
		
		this.PPanel = new PPanel(spieler);
		
    addMouseListener(
			new MouseAdapter() {
				public void mouseClicked(MouseEvent e)
					{
					int i, j, p;
					Point pt = e.getPoint();
					
					// Kein Listener - keine Arbeit
					if (listener == null)
						return;
					
					// Auf Spielfeld geklickt?
					for (i = 0; i < 40; i++)
						{
						if (isInRect(pt, field[i].pos, 20, 20))
							{
							// Auf Stein geklickt?
							p = getStone(i);
							if (p != KEIN)
								listener.selected(SelectEvent.create(field[i].besetzt, p));
							return;
							}
						}
					
					// Auf Zielfeld geklickt?
					for (j = 0; j < MAX; j++)
						{
						for (i = 0; i < 4; i++)
							{
							if (isInRect(pt, house[j][i].pos, 20, 20))
								{
								// Auf Stein geklickt?
								p = getHouseStone(j, i);
								if (p != KEIN)
									listener.selected(SelectEvent.create(j, p));
								return;
								}
							}
						}
					}
				}
			);
		}
	
	public void setStatus(String text, Color c){
		this.status.setForeground(c);
		this.status.setText(text);
	}	
		
	public Label getStatusBar(){
		return this.status;
	}
	
	public Panel getPPanel(){
		return this.PPanel;
	}
	
	public Button getButton(){
		return this.button;
	}
	
	public void Button(String state){
		if (state.equals("on")){
			this.button.enable();
		}else{ this.button.disable();}
	}
	
	// Ermittelt, ob der Punkt pt innerhalb eines Rechtecks liegt
	private boolean isInRect(Point pt, Point rc, int width, int height)
		{
		return ((pt.x >= rc.x) && (pt.y >= rc.y) && (pt.x <= (rc.x + width)) && (pt.y <= (rc.y + height)));
		}
	
	
	public void reset()
		{
		int i, j;
		
		for (j = MIN; j < MAX; j++)
			{
			spieler[j].reset();
			
			for (i = 0; i < 4; i++)
				{
				home[j][i].besetzt = j;
				house[j][i].besetzt = KEIN;
				}
			}
		
		for (i = 0; i < 40; i++)
			field[i].besetzt = KEIN;
			
		for (j = MIN; j < MAX; j++)
   	{
			spieler[j].getWuerfel().visible = false;
   	}	
		
		repaint();
		}
	
	// Listener fr Steinauswahl setzen
	public void setSelectListener(SelectListener l)
		{
		listener = l;
		}
	
	// Index des Steins auf einem Zielfeld ermitteln
	private int getHouseStone(int player, int f)
		{
		int i;
		
		try	{
			if (house[player][f].besetzt == KEIN)
				return (KEIN);
			
			f += 40;
			for (i = 0; i < 4; i++)
				{
				if (f == spieler[player].getStonePos(i))
					return (i);
				}
			}
		catch (Exception e) { }
		return (KEIN);
		}
	
	// ermittelt, ob der Spieler dreimal wrfeln darf
	public boolean mayRepeat(int player)
		{
		if (spieler[player].athome == 4)
			return (true);
		
		for (int i = 3; i >= spieler[player].athome; i--)
			{
			if (house[player][i].besetzt != player)
				return (false);
			}
		
		return (true);
		}
	
	// Index des Steins auf einem Spielfeld ermitteln
	private int getStone(int f)
		{
		int i, player;
		
		try	{
			player = field[f].besetzt;
			
			for (i = 0; i < 4; i++)
				{
				if (f == spieler[player].getStonePos(i))
					return (i);
				}
			}
		catch (Exception e) { }
		return (KEIN);
		}
	
	// Index des Steins auf dem Startfeld des Spielers ermitteln
	public int getStartStone(int player)
		{
		try	{
			return (getStone(spieler[player].begin));
			}
		catch (Exception e)
			{
			return (KEIN);
			}
		}
	
	// Einen Spielzug ausfhren: Spieler player setzt Stein stone um n Felder
	// Wenn test true, dann wird nur geprft, ob der Zug mglich wre.
	public boolean go(int player, int stone, int n, boolean test)
		{
		int i, me, other;
		
		if ((player < MIN) || (player >= MAX) || (stone < -1) || (stone >= 4))
			return (false);
		
		// Wenn Stone -1, dann Stein aus dem Haus setzen
		if (stone == -1)
			{
			if (test)
				return (false);
			// Noch Steine im Haus?
			if (spieler[player].athome == 0)
				return (false);
			
			me = spieler[player].begin;
			other = field[me].besetzt;
			
			// Startfeld schon von mir besetzt?
			if (other == player)
				return (false);
			
			// Startfeld von anderem Spieler besetzt?
			if (other != KEIN)
				{
				// Spieler rauswerfen
				spieler[other].stein[getStone(me)] = -1;
				spieler[other].athome++;
				}
			
			// Nchsten freien Stein ermitteln
			for (i = 0; (i < 4) && (spieler[player].stein[i] != -1); i++);
			
			// und raussetzen
			spieler[player].stein[i] = 0;
			field[me].besetzt = player;
			spieler[player].athome--;
			repaint();
			
			return (true);
			}
		
		me = spieler[player].stein[stone];
		
		// Stein noch im Haus? Kann nicht gesetzt werden
		if (me == -1)
			return (false);
		
		i = spieler[player].getStonePos(stone);
		
		// Stein wird ins Ziel gesetzt
		if ((me + n) >= 40)
			{
			me = me + n - 40;
			
			// Zug pat nicht?
			if (me >= 4)
				return (false);
			
			// Feld schon besetzt?
			if (house[player][me].besetzt == player)
				return (false);
			
			// Stein setzen
			if (!test)
				{
				if (i < 40)
					spieler[player].inhouse++;
				house[player][me].besetzt = player;
				}
			}
		else	// Stein nicht ins Ziel gesetzt
			{
			me = (i + n) % 40;
			other = field[me].besetzt;
			
			// Feld schon von mir besetzt?
			if (other == player)
				return (false);
			
			// Feld von anderem Spieler besetzt?
			if (!test && (other != KEIN))
				{
				// rauswerfen
				spieler[other].stein[getStone(me)] = -1;
				spieler[other].athome++;
				}
			
			// Stein setzen
			if (!test)
				field[me].besetzt = player;
			}
		
		if (!test)
			{
			// Altes Feld rumen
			if (i >= 40)
				house[player][i - 40].besetzt = KEIN;
			else
				field[i].besetzt = KEIN;
			
			// Steinposition setzen
			spieler[player].stein[stone] += n;
			repaint();
			}
		
		return (true);
		}
	
	// Prfen, ob Spieler player einen Stein um n Felder setzen kann
	public boolean canMove(int player, int n)
		{
		int i;
		
		if ((player < MIN) || (player >= MAX))
			return (false);
		
		for (i = 0; (i < 4) && !go(player, i, n, true); i++);
		
		return (i != 4);
		}
	
	public void paint(Graphics g)
		{
		int i, j;
				
		for (j = MIN; j < MAX; j++)
			{
			for (i = 0; i < 4; i++)
				{
				g.setColor(i < spieler[j].athome ? spieler[j].color : spieler[j].color_noton);
				g.fillOval(home[j][i].pos.x, home[j][i].pos.y, 21, 21);
				g.setColor(Color.black);
				g.drawOval(home[j][i].pos.x, home[j][i].pos.y, 20, 20);
				}
			}
		
		for (j = MIN; j < MAX; j++)
			{
			for (i = 0; i < 4; i++)
				{
				g.setColor((house[j][i].besetzt != KEIN) ? spieler[j].color : spieler[j].color_noton);
				g.fillOval(house[j][i].pos.x, house[j][i].pos.y, 17, 17);
				g.setColor(Color.black);
				g.drawOval(house[j][i].pos.x, house[j][i].pos.y, 16, 16);
				}
			}
		
		for (i = 0; i < 40; i++)
			{
			if (field[i].besetzt != KEIN)
				g.setColor(spieler[field[i].besetzt].color);
			else
				{
				g.setColor(Color.white);
				for (j = MIN; j < MAX; j++)
					{
					if (i == spieler[j].begin)
						g.setColor(spieler[j].color_noton);
					}
				}
			g.fillOval(field[i].pos.x, field[i].pos.y, 21, 21);
			g.setColor(Color.black);
			g.drawOval(field[i].pos.x, field[i].pos.y, 20, 20);
		}
		
		
   for (j = MIN; j < MAX; j++)
   {
		spieler[j].getWuerfel().paint(g);
   }
   
   this.PPanel.setText();
		
	}
	
	private static GridBagConstraints makegbc(int x, int y, int width, int height){
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.fill = GridBagConstraints.BOTH;
    gbc.gridx = x;
    gbc.gridy = y;
    gbc.gridwidth = width;
    gbc.gridheight = height;
    gbc.insets = new Insets(1, 1, 1, 1);
    return gbc;
	}
	
	public void actionPerformed(ActionEvent event)
  	{
    String cmd = event.getActionCommand();
   	try{
     		System.out.println(cmd);
   		if (cmd.equals("Wrfeln")) {
   			System.exit(0);
     	}
  	}catch(Exception ex){
		MsgBox.OKDialog("Fehler",ex.toString());
  	}

  }

public class PPanel extends Panel{
	Player[] p;
	
	public PPanel(Player[] p){
		super();
		this.p = p;
		GridBagLayout gb = new GridBagLayout();
		setLayout(gb);
  	//p.setBackground(Color.darkGray);
  	//this.setForeground(Color.lightGray);
  	
  	Label l = new Label("  Punkte:");
		l.setAlignment(Label.LEFT);
		gb.setConstraints(l, makegbc(0,0,1,1));
		add(l);
  	
   	for (int j = 0; j < p.length; j++)
   	{
			l = new Label(Integer.toString(this.p[j].getScore()));
			l.setForeground(this.p[j].color);
			l.setAlignment(Label.LEFT);
			gb.setConstraints(l, makegbc(j+1,0,1,1));
			add(l);
   	}

	}
	
	public void setText(){
		Component[] slots = this.getComponents();

		for (int j = MIN; j < p.length; j++)
   	{
			((Label)slots[j+1]).setText(Integer.toString(this.p[j].getScore()));
   		//		System.err.println(slots[j]+" " +this.p[j].getScore());
   	}
	}

}

}